Index: palm/trunk/SOURCE/diffusion_v.f90
===================================================================
--- palm/trunk/SOURCE/diffusion_v.f90	(revision 4901)
+++ palm/trunk/SOURCE/diffusion_v.f90	(revision 1)
@@ -1,47 +1,67 @@
-!> @file diffusion_v.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ MODULE diffusion_v_mod
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
-!
+! 
 !
 ! Former revisions:
 ! -----------------
-! $Id$
-! Update ACC directives for downward facing USM and LSM surfaces
-!
-! 4671 2020-09-09 20:27:58Z pavelkrc
-! Implementation of downward facing USM and LSM surfaces
+! $Log: diffusion_v.f90,v $
+! Revision 1.15  2006/02/23 10:36:00  raasch
+! nzb_2d replaced by nzb_v_outer in horizontal diffusion and by nzb_v_inner
+! or nzb_diff_v, respectively, in vertical diffusion,
+! wall functions added for north and south walls, +z0 in argument list,
+! terms containing w(k-1,..) are removed from the Prandtl-layer equation
+! because they cause errors at the edges of topography
+! WARNING: loops containing the MAX function are still not properly vectorized!
+!
+! Revision 1.14  2005/03/26 20:09:56  raasch
+! Extension of horizontal loop upper bounds for non-cyclic boundary conditions,
+! additional damping layer at the outflow in case of non-cyclic lateral
+! boundaries, additional argument km_damp_x
+!
+! Revision 1.13  2004/01/30 10:21:56  raasch
+! Scalar lower k index nzb replaced by 2d-array nzb_2d
+!
+! Revision 1.12  2003/03/12 16:26:31  raasch
+! Full code replaced in the call for all gridpoints instead of calling the
+! _ij version (required by NEC, because otherwise no vectorization)
+!
+! Revision 1.11  2002/06/11 12:53:46  raasch
+! Former subroutine changed to a module which allows to be called for all grid
+! points of a single vertical column with index i,j or for all grid points by
+! using function overloading.
+!
+! Revision 1.10  2001/08/21 08:29:31  raasch
+! Special treatment at k=1 generally if momentum flux is prescribed (not only in
+! case of a Prandtl layer)
+!
+! Revision 1.9  2001/03/30 07:12:19  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.8  2001/01/22 06:18:41  raasch
+! Module test_variables removed
+!
+! Revision 1.7  2000/07/03 12:58:14  raasch
+! dummy arguments, whose corresponding actual arguments are pointers,
+! are now also defined as pointers,
+! all comments translated into English
+!
+! Revision 1.6  2000/03/14 13:58:18  schroeter
+! vertical impulse fluxes are computed over dz at the
+! top of the Prandtl-layer
+!
+! Revision 1.5  98/07/06  12:12:05  12:12:05  raasch (Siegfried Raasch)
+! + USE test_variables
 ! 
-! 4583 2020-06-29 12:36:47Z raasch
-! file re-formatted to follow the PALM coding standard
-!
-! 4360 2020-01-07 11:25:50Z suehring
-! Introduction of wall_flags_total_0, which currently sets bits based on static topography
-! information used in wall_flags_static_0
-!
-! 4329 2019-12-10 15:46:36Z motisi
-! Renamed wall_flags_0 to wall_flags_static_0
-!
-! 4182 2019-08-22 15:20:23Z scharf
-! Corrected "Former revisions" section
-!
-! 3655 2019-01-07 16:51:22Z knoop
-! OpenACC port for SPEC
+! Revision 1.4  1998/01/23 09:57:18  raasch
+! Einbau der Prandtl-Schicht
+!
+! Revision 1.3  1997/09/12 07:24:20  raasch
+! Leerzeilen mussten entfernt werden
+!
+! Revision 1.2  1997/09/12 06:43:46  raasch
+! HP-Compiler erfordert & am Beginn von Fortsetzungszeilen
 !
 ! Revision 1.1  1997/09/12 06:24:01  raasch
@@ -51,8 +71,6 @@
 ! Description:
 ! ------------
-!> Diffusion term of the v-component
-!--------------------------------------------------------------------------------------------------!
- MODULE diffusion_v_mod
-
+! Diffusion term of the v-component
+!------------------------------------------------------------------------------!
 
     PRIVATE
@@ -67,239 +85,144 @@
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for all grid points
-!--------------------------------------------------------------------------------------------------!
-    SUBROUTINE diffusion_v
-
-       USE arrays_3d,                                                                              &
-           ONLY:  ddzu, ddzw, drho_air, km, rho_air_zw, tend, u, v, w 
-
-       USE control_parameters,                                                                     &
-           ONLY:  constant_top_momentumflux, use_surface_fluxes,  use_top_fluxes
-
-       USE grid_variables,                                                                         &
-           ONLY:  ddx, ddy, ddy2
-
-       USE indices,                                                                                &
-           ONLY:  nxl, nxr, nyn, nysv, nzb, nzt, wall_flags_total_0
-
-       USE kinds
-
-       USE surface_mod,                                                                            &
-           ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h, surf_usm_v
+!------------------------------------------------------------------------------!
+! Call for all grid points
+!------------------------------------------------------------------------------!
+    SUBROUTINE diffusion_v( ddzu, ddzw, km, km_damp_x, tend, u, v, vsws, w, z0 )
+
+       USE control_parameters
+       USE grid_variables
+       USE indices
 
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i             !< running index x direction
-       INTEGER(iwp) ::  j             !< running index y direction
-       INTEGER(iwp) ::  k             !< running index z direction
-       INTEGER(iwp) ::  l             !< running index of surface type, south- or north-facing wall
-       INTEGER(iwp) ::  m             !< running index surface elements
-       INTEGER(iwp) ::  surf_e        !< End index of surface elements at (j,i)-gridpoint
-       INTEGER(iwp) ::  surf_s        !< Start index of surface elements at (j,i)-gridpoint
-
-       REAL(wp)     ::  flag          !< flag to mask topography grid points
-       REAL(wp)     ::  kmxm          !< diffusion coefficient on leftward side of the v-gridbox - interpolated onto xu-yv grid
-       REAL(wp)     ::  kmxp          !< diffusion coefficient on rightward side of the v-gridbox - interpolated onto xu-yv grid
-       REAL(wp)     ::  kmzm          !< diffusion coefficient on bottom of the gridbox - interpolated onto yv-zw grid
-       REAL(wp)     ::  kmzp          !< diffusion coefficient on top of the gridbox - interpolated onto yv-zw grid
-       REAL(wp)     ::  mask_bottom   !< flag to mask vertical upward-facing surface
-       REAL(wp)     ::  mask_east     !< flag to mask vertical surface south of the grid point
-       REAL(wp)     ::  mask_west     !< flag to mask vertical surface north of the grid point
-       REAL(wp)     ::  mask_top      !< flag to mask vertical downward-facing surface
-
-       !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j, k, l, m) &
-       !$ACC PRIVATE(surf_e, surf_s, flag, kmxm, kmxp, kmzm, kmzp) &
-       !$ACC PRIVATE(mask_bottom, mask_east, mask_west, mask_top) &
-       !$ACC PRESENT(wall_flags_total_0, km) &
-       !$ACC PRESENT(u, v, w) &
-       !$ACC PRESENT(ddzu, ddzw, drho_air, rho_air_zw) &
-       !$ACC PRESENT(surf_def_h(0:2), surf_def_v(2:3)) &
-       !$ACC PRESENT(surf_lsm_h(0:1), surf_lsm_v(2:3)) &
-       !$ACC PRESENT(surf_usm_h(0:1), surf_usm_v(2:3)) &
-       !$ACC PRESENT(tend)
+       INTEGER ::  i, j, k
+       REAL    ::  kmxm_x, kmxm_y, kmxp_x, kmxp_y, kmzm, kmzp, vsus
+       REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt), km_damp_x(nxl-1:nxr+1)
+       REAL    ::  z0(nys-1:nyn+1,nxl-1:nxr+1)
+       REAL    ::  tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
+       REAL, DIMENSION(:,:),   POINTER ::  vsws
+       REAL, DIMENSION(:,:,:), POINTER ::  km, u, v, w
+
        DO  i = nxl, nxr
-          DO  j = nysv, nyn
+          DO  j = nys, nyn+vynp
 !
 !--          Compute horizontal diffusion
-             DO  k = nzb+1, nzt
-
-!
-!--             Predetermine flag to mask topography and wall-bounded grid points.
-!--             It is sufficient to masked only east- and west-facing surfaces, which need special
-!--             treatment for the v-component.
-                flag      = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i),   2 ) )
-                mask_east = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i+1), 2 ) )
-                mask_west = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i-1), 2 ) )
+             DO  k = nzb_v_outer(j,i)+1, nzt
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmxp = 0.25_wp * ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
-                kmxm = 0.25_wp * ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
-
-                tend(k,j,i) = tend(k,j,i) +          (                                             &
-                                mask_east * kmxp * (                                               &
-                                       ( v(k,j,i+1) - v(k,j,i)     ) * ddx                         &
-                                     + ( u(k,j,i+1) - u(k,j-1,i+1) ) * ddy                         &
-                                                   )                                               &
-                              - mask_west * kmxm * (                                               &
-                                       ( v(k,j,i) - v(k,j,i-1) ) * ddx                             &
-                                     + ( u(k,j,i) - u(k,j-1,i) ) * ddy                             &
-                                                   )                                               &
-                                                     ) * ddx  * flag                               &
-                                          + 2.0_wp * (                                             &
-                                        km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i)   )                  &
-                                      - km(k,j-1,i) * ( v(k,j,i)   - v(k,j-1,i) )                  &
-                                                     ) * ddy2 * flag
-
+                kmxp_x = 0.25 * &
+                         ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
+                kmxm_x = 0.25 * &
+                         ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
+                kmxp_y = kmxp_x
+                kmxm_y = kmxm_x
+!
+!--             Increase diffusion at the outflow boundary in case of
+!--             non-cyclic lateral boundaries. Damping is only needed for
+!--             velocity components parallel to the outflow boundary in
+!--             the direction normal to the outflow boundary.
+                IF ( bc_lr /= 'cyclic' )  THEN
+                   kmxp_x = MAX( kmxp_x, km_damp_x(i) )
+                   kmxm_x = MAX( kmxm_x, km_damp_x(i) )
+                ENDIF
+
+                tend(k,j,i) = tend(k,j,i)                                    &
+                      & + ( kmxp_x * ( v(k,j,i+1) - v(k,j,i)     ) * ddx     &
+                      &   + kmxp_y * ( u(k,j,i+1) - u(k,j-1,i+1) ) * ddy     &
+                      &   - kmxm_x * ( v(k,j,i) - v(k,j,i-1) ) * ddx         &
+                      &   - kmxm_y * ( u(k,j,i) - u(k,j-1,i) ) * ddy         &
+                      &   ) * ddx                                            &
+                      & + 2.0 * (                                            &
+                      &           km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i) )    &
+                      &         - km(k,j-1,i) * ( v(k,j,i) - v(k,j-1,i) )    &
+                      &         ) * ddy2
              ENDDO
 
 !
-!--          Add horizontal momentum flux v'u' at east- (l=2) and west-facing (l=3) surfaces. Note,
-!--          in the the flat case, loops won't be entered as start_index > end_index. Furtermore,
-!--          note, no vertical natural surfaces so far.
-!--          Default-type surfaces
-             DO  l = 2, 3
-                surf_s = surf_def_v(l)%start_index(j,i)
-                surf_e = surf_def_v(l)%end_index(j,i)
-                DO  m = surf_s, surf_e
-                   k           = surf_def_v(l)%k(m)
-                   tend(k,j,i) = tend(k,j,i) + surf_def_v(l)%mom_flux_uv(m) * ddx
-                ENDDO
-             ENDDO
-!
-!--          Natural-type surfaces
-             DO  l = 2, 3
-                surf_s = surf_lsm_v(l)%start_index(j,i)
-                surf_e = surf_lsm_v(l)%end_index(j,i)
-                DO  m = surf_s, surf_e
-                   k           = surf_lsm_v(l)%k(m)
-                   tend(k,j,i) = tend(k,j,i) + surf_lsm_v(l)%mom_flux_uv(m) * ddx
-                ENDDO
-             ENDDO
-!
-!--          Urban-type surfaces
-             DO  l = 2, 3
-                surf_s = surf_usm_v(l)%start_index(j,i)
-                surf_e = surf_usm_v(l)%end_index(j,i)
-                DO  m = surf_s, surf_e
-                   k           = surf_usm_v(l)%k(m)
-                   tend(k,j,i) = tend(k,j,i) + surf_usm_v(l)%mom_flux_uv(m) * ddx
-                ENDDO
-             ENDDO
-!
-!--          Compute vertical diffusion. In case of simulating a surface layer, respective grid
-!--          diffusive fluxes are masked (flag 10) within this loop, and added further below, else,
-!--          simple gradient approach is applied. Model top is also mask if top-momentum flux is
-!--          given.
-             DO  k = nzb+1, nzt
-!
-!--             Determine flags to mask topography below and above. Flag 2 is used to mask
-!--             topography in general, while flag 8 implies also information about
-!--             use_surface_fluxes. Flag 9 is used to control momentum flux at model top.
-                mask_bottom = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k-1,j,i), 8 ) )
-                mask_top    = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k+1,j,i), 8 ) ) *   &
-                              MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k+1,j,i), 9 ) )
-                flag        = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 2 ) )
-!
-!--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzp = 0.25_wp * ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
-                kmzm = 0.25_wp * ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
-
-                tend(k,j,i) = tend(k,j,i)                                                          &
-                              & + ( kmzp * ( ( v(k+1,j,i) - v(k,j,i) ) * ddzu(k+1)                 &
-                              &            + ( w(k,j,i) - w(k,j-1,i) ) * ddy                       &
-                              &            ) * rho_air_zw(k)   * mask_top                          &
-                              &   - kmzm * ( ( v(k,j,i)   - v(k-1,j,i)   ) * ddzu(k)               &
-                              &            + ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy                   &
-                              &            ) * rho_air_zw(k-1) * mask_bottom                       &
-                              &   ) * ddzw(k) * drho_air(k) * flag
-             ENDDO
-
-!
-!--          Vertical diffusion at the first grid point above the surface, if the momentum flux at
-!--          the bottom is given by the Prandtl law or if it is prescribed by the user.
-!--          Difference quotient of the momentum flux is not formed over half of the grid spacing
-!--          (2.0*ddzw(k)) any more, since the comparison with other (LES) models showed that the
-!--          values of the momentum flux becomes too large in this case.
-             IF ( use_surface_fluxes )  THEN
-!
-!--             Default-type surfaces, upward-facing
-                surf_s = surf_def_h(0)%start_index(j,i)
-                surf_e = surf_def_h(0)%end_index(j,i)
-                DO  m = surf_s, surf_e
-                   k   = surf_def_h(0)%k(m)
-
-                   tend(k,j,i) = tend(k,j,i)                                                       &
-                                 + ( - ( - surf_def_h(0)%vsws(m) ) ) * ddzw(k) * drho_air(k)
-                ENDDO
-!
-!--             Default-type surfaces, dowward-facing
-                surf_s = surf_def_h(1)%start_index(j,i)
-                surf_e = surf_def_h(1)%end_index(j,i)
-                DO  m = surf_s, surf_e
-                   k   = surf_def_h(1)%k(m)
-
-                   tend(k,j,i) = tend(k,j,i)                                                       &
-                                 + ( - surf_def_h(1)%vsws(m) ) * ddzw(k) * drho_air(k)
-                ENDDO
-!
-!--             Natural-type surfaces, upward-facing
-                surf_s = surf_lsm_h(0)%start_index(j,i)
-                surf_e = surf_lsm_h(0)%end_index(j,i)
-                DO  m = surf_s, surf_e
-                   k   = surf_lsm_h(0)%k(m)
-
-                   tend(k,j,i) = tend(k,j,i)                                                       &
-                                 + ( - ( - surf_lsm_h(0)%vsws(m) ) ) * ddzw(k) * drho_air(k)
-
-                ENDDO
-!
-!--             Natural-type surfaces, downward-facing
-                surf_s = surf_lsm_h(1)%start_index(j,i)
-                surf_e = surf_lsm_h(1)%end_index(j,i)
-                DO  m = surf_s, surf_e
-                   k   = surf_lsm_h(1)%k(m)
-
-                   tend(k,j,i) = tend(k,j,i)                                                       &
-                                 +  ( - surf_lsm_h(1)%vsws(m) ) * ddzw(k) * drho_air(k)
-
-                ENDDO
-!
-!--             Urban-type surfaces, upward-facing
-                surf_s = surf_usm_h(0)%start_index(j,i)
-                surf_e = surf_usm_h(0)%end_index(j,i)
-                DO  m = surf_s, surf_e
-                   k   = surf_usm_h(0)%k(m)
-
-                   tend(k,j,i) = tend(k,j,i)                                                       &
-                                 + ( - ( - surf_usm_h(0)%vsws(m) ) ) * ddzw(k) * drho_air(k)
-
-                ENDDO
-!
-!--             Urban-type surfaces, downward-facing
-                surf_s = surf_usm_h(1)%start_index(j,i)
-                surf_e = surf_usm_h(1)%end_index(j,i)
-                DO  m = surf_s, surf_e
-                   k   = surf_usm_h(1)%k(m)
-
-                   tend(k,j,i) = tend(k,j,i)                                                       &
-                                 + ( - surf_usm_h(1)%vsws(m) ) * ddzw(k) * drho_air(k)
-
+!--          Wall functions at the left and right walls, respectively
+             IF ( wall_v(j,i) /= 0.0 )  THEN
+                DO  k = nzb_v_inner(j,i)+1, nzb_v_outer(j,i)
+                   vsus   = kappa * v(k,j,i) / LOG( 0.5 * dx / z0(j,i))
+                   vsus   = -vsus * ABS( vsus )
+                   kmxp_x = 0.25 * &
+                            ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
+                   kmxm_x = 0.25 * &
+                            ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
+                   kmxp_y = kmxp_x
+                   kmxm_y = kmxm_x
+!
+!--                Increase diffusion at the outflow boundary in case of
+!--                non-cyclic lateral boundaries. Damping is only needed for
+!--                velocity components parallel to the outflow boundary in
+!--                the direction normal to the outflow boundary.
+                   IF ( bc_lr /= 'cyclic' )  THEN
+                      kmxp_x = MAX( kmxp_x, km_damp_x(i) )
+                      kmxm_x = MAX( kmxm_x, km_damp_x(i) )
+                   ENDIF
+
+                   tend(k,j,i) = tend(k,j,i)                                   &
+                                 + 2.0 * (                                     &
+                                       km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i) ) &
+                                     - km(k,j-1,i) * ( v(k,j,i) - v(k,j-1,i) ) &
+                                         ) * ddy2                              &
+                                 + (   fxp(j,i) * (                            &
+                                  kmxp_x * ( v(k,j,i+1) - v(k,j,i)     ) * ddx &
+                                + kmxp_y * ( u(k,j,i+1) - u(k,j-1,i+1) ) * ddy &
+                                                  )                            &
+                                     - fxm(j,i) * (                            &
+                                  kmxm_x * ( v(k,j,i) - v(k,j,i-1) ) * ddx     &
+                                + kmxm_y * ( u(k,j,i) - u(k,j-1,i) ) * ddy     &
+                                                  )                            &
+                                     + wall_v(j,i) * vsus                      &
+                                   ) * ddx
                 ENDDO
              ENDIF
-!
-!--          Add momentum flux at model top
-             IF ( use_top_fluxes  .AND.  constant_top_momentumflux )  THEN
-                surf_s = surf_def_h(2)%start_index(j,i)
-                surf_e = surf_def_h(2)%end_index(j,i)
-                DO  m = surf_s, surf_e
-
-                   k   = surf_def_h(2)%k(m)
-
-                   tend(k,j,i) = tend(k,j,i)                                                       &
-                                 + ( - surf_def_h(2)%vsws(m) ) * ddzw(k) * drho_air(k)
-                ENDDO
+
+!
+!--          Compute vertical diffusion. In case of simulating a Prandtl
+!--          layer, index k starts at nzb_v_inner+2.
+             DO  k = nzb_diff_v(j,i), nzt
+!
+!--             Interpolate eddy diffusivities on staggered gridpoints
+                kmzp = 0.25 * &
+                       ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
+                kmzm = 0.25 * &
+                       ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
+
+                tend(k,j,i) = tend(k,j,i)                                    &
+                      & + ( kmzp * ( ( v(k+1,j,i) - v(k,j,i) ) * ddzu(k+1)   &
+                      &            + ( w(k,j,i) - w(k,j-1,i) ) * ddy         &
+                      &            )                                         &
+                      &   - kmzm * ( ( v(k,j,i)   - v(k-1,j,i)   ) * ddzu(k) &
+                      &            + ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy     &
+                      &            )                                         &
+                      &   ) * ddzw(k)
+             ENDDO
+
+!
+!--          Vertical diffusion at the first grid point above the surface,
+!--          if the momentum flux at the bottom is given by the Prandtl law
+!--          or if it is prescribed by the user.
+!--          Difference quotient of the momentum flux is not formed over
+!--          half of the grid spacing (2.0*ddzw(k)) any more, since the
+!--          comparison with other (LES) modell showed that the values of
+!--          the momentum flux becomes too large in this case.
+!--          The term containing w(k-1,..) (see above equation) is removed here
+!--          because the vertical velocity is assumed to be zero at the surface.
+             IF ( use_surface_fluxes )  THEN
+                k = nzb_v_inner(j,i)+1
+!
+!--             Interpolate eddy diffusivities on staggered gridpoints
+                kmzp = 0.25 * &
+                       ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
+                kmzm = 0.25 * &
+                       ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
+
+                tend(k,j,i) = tend(k,j,i)                                    &
+                      & + ( kmzp * ( w(k,j,i) - w(k,j-1,i)     ) * ddy       &
+                      &   ) * ddzw(k)                                        &
+                      & + ( kmzp * ( v(k+1,j,i) - v(k,j,i) ) * ddzu(k+1)     &
+                      &   + vsws(j,i)                                        &
+                      &   ) * ddzw(k)
              ENDIF
 
